// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from rosauth:srv/Authentication.idl
// generated code does not contain a copyright notice

#ifndef ROSAUTH__SRV__DETAIL__AUTHENTICATION__BUILDER_HPP_
#define ROSAUTH__SRV__DETAIL__AUTHENTICATION__BUILDER_HPP_

#include "rosauth/srv/detail/authentication__struct.hpp"
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <utility>


namespace rosauth
{

namespace srv
{

namespace builder
{

class Init_Authentication_Request_end
{
public:
  explicit Init_Authentication_Request_end(::rosauth::srv::Authentication_Request & msg)
  : msg_(msg)
  {}
  ::rosauth::srv::Authentication_Request end(::rosauth::srv::Authentication_Request::_end_type arg)
  {
    msg_.end = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rosauth::srv::Authentication_Request msg_;
};

class Init_Authentication_Request_level
{
public:
  explicit Init_Authentication_Request_level(::rosauth::srv::Authentication_Request & msg)
  : msg_(msg)
  {}
  Init_Authentication_Request_end level(::rosauth::srv::Authentication_Request::_level_type arg)
  {
    msg_.level = std::move(arg);
    return Init_Authentication_Request_end(msg_);
  }

private:
  ::rosauth::srv::Authentication_Request msg_;
};

class Init_Authentication_Request_t
{
public:
  explicit Init_Authentication_Request_t(::rosauth::srv::Authentication_Request & msg)
  : msg_(msg)
  {}
  Init_Authentication_Request_level t(::rosauth::srv::Authentication_Request::_t_type arg)
  {
    msg_.t = std::move(arg);
    return Init_Authentication_Request_level(msg_);
  }

private:
  ::rosauth::srv::Authentication_Request msg_;
};

class Init_Authentication_Request_rand
{
public:
  explicit Init_Authentication_Request_rand(::rosauth::srv::Authentication_Request & msg)
  : msg_(msg)
  {}
  Init_Authentication_Request_t rand(::rosauth::srv::Authentication_Request::_rand_type arg)
  {
    msg_.rand = std::move(arg);
    return Init_Authentication_Request_t(msg_);
  }

private:
  ::rosauth::srv::Authentication_Request msg_;
};

class Init_Authentication_Request_dest
{
public:
  explicit Init_Authentication_Request_dest(::rosauth::srv::Authentication_Request & msg)
  : msg_(msg)
  {}
  Init_Authentication_Request_rand dest(::rosauth::srv::Authentication_Request::_dest_type arg)
  {
    msg_.dest = std::move(arg);
    return Init_Authentication_Request_rand(msg_);
  }

private:
  ::rosauth::srv::Authentication_Request msg_;
};

class Init_Authentication_Request_client
{
public:
  explicit Init_Authentication_Request_client(::rosauth::srv::Authentication_Request & msg)
  : msg_(msg)
  {}
  Init_Authentication_Request_dest client(::rosauth::srv::Authentication_Request::_client_type arg)
  {
    msg_.client = std::move(arg);
    return Init_Authentication_Request_dest(msg_);
  }

private:
  ::rosauth::srv::Authentication_Request msg_;
};

class Init_Authentication_Request_mac
{
public:
  Init_Authentication_Request_mac()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_Authentication_Request_client mac(::rosauth::srv::Authentication_Request::_mac_type arg)
  {
    msg_.mac = std::move(arg);
    return Init_Authentication_Request_client(msg_);
  }

private:
  ::rosauth::srv::Authentication_Request msg_;
};

}  // namespace builder

}  // namespace srv

template<typename MessageType>
auto build();

template<>
inline
auto build<::rosauth::srv::Authentication_Request>()
{
  return rosauth::srv::builder::Init_Authentication_Request_mac();
}

}  // namespace rosauth


namespace rosauth
{

namespace srv
{

namespace builder
{

class Init_Authentication_Response_authenticated
{
public:
  Init_Authentication_Response_authenticated()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  ::rosauth::srv::Authentication_Response authenticated(::rosauth::srv::Authentication_Response::_authenticated_type arg)
  {
    msg_.authenticated = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rosauth::srv::Authentication_Response msg_;
};

}  // namespace builder

}  // namespace srv

template<typename MessageType>
auto build();

template<>
inline
auto build<::rosauth::srv::Authentication_Response>()
{
  return rosauth::srv::builder::Init_Authentication_Response_authenticated();
}

}  // namespace rosauth

#endif  // ROSAUTH__SRV__DETAIL__AUTHENTICATION__BUILDER_HPP_
