// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rosauth:srv/Authentication.idl
// generated code does not contain a copyright notice
#include "rosauth/srv/detail/authentication__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

// Include directives for member types
// Member `mac`
// Member `client`
// Member `dest`
// Member `rand`
// Member `level`
#include "rosidl_runtime_c/string_functions.h"
// Member `t`
// Member `end`
#include "builtin_interfaces/msg/detail/time__functions.h"

bool
rosauth__srv__Authentication_Request__init(rosauth__srv__Authentication_Request * msg)
{
  if (!msg) {
    return false;
  }
  // mac
  if (!rosidl_runtime_c__String__init(&msg->mac)) {
    rosauth__srv__Authentication_Request__fini(msg);
    return false;
  }
  // client
  if (!rosidl_runtime_c__String__init(&msg->client)) {
    rosauth__srv__Authentication_Request__fini(msg);
    return false;
  }
  // dest
  if (!rosidl_runtime_c__String__init(&msg->dest)) {
    rosauth__srv__Authentication_Request__fini(msg);
    return false;
  }
  // rand
  if (!rosidl_runtime_c__String__init(&msg->rand)) {
    rosauth__srv__Authentication_Request__fini(msg);
    return false;
  }
  // t
  if (!builtin_interfaces__msg__Time__init(&msg->t)) {
    rosauth__srv__Authentication_Request__fini(msg);
    return false;
  }
  // level
  if (!rosidl_runtime_c__String__init(&msg->level)) {
    rosauth__srv__Authentication_Request__fini(msg);
    return false;
  }
  // end
  if (!builtin_interfaces__msg__Time__init(&msg->end)) {
    rosauth__srv__Authentication_Request__fini(msg);
    return false;
  }
  return true;
}

void
rosauth__srv__Authentication_Request__fini(rosauth__srv__Authentication_Request * msg)
{
  if (!msg) {
    return;
  }
  // mac
  rosidl_runtime_c__String__fini(&msg->mac);
  // client
  rosidl_runtime_c__String__fini(&msg->client);
  // dest
  rosidl_runtime_c__String__fini(&msg->dest);
  // rand
  rosidl_runtime_c__String__fini(&msg->rand);
  // t
  builtin_interfaces__msg__Time__fini(&msg->t);
  // level
  rosidl_runtime_c__String__fini(&msg->level);
  // end
  builtin_interfaces__msg__Time__fini(&msg->end);
}

rosauth__srv__Authentication_Request *
rosauth__srv__Authentication_Request__create()
{
  rosauth__srv__Authentication_Request * msg = (rosauth__srv__Authentication_Request *)malloc(sizeof(rosauth__srv__Authentication_Request));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosauth__srv__Authentication_Request));
  bool success = rosauth__srv__Authentication_Request__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rosauth__srv__Authentication_Request__destroy(rosauth__srv__Authentication_Request * msg)
{
  if (msg) {
    rosauth__srv__Authentication_Request__fini(msg);
  }
  free(msg);
}


bool
rosauth__srv__Authentication_Request__Sequence__init(rosauth__srv__Authentication_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rosauth__srv__Authentication_Request * data = NULL;
  if (size) {
    data = (rosauth__srv__Authentication_Request *)calloc(size, sizeof(rosauth__srv__Authentication_Request));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosauth__srv__Authentication_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosauth__srv__Authentication_Request__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosauth__srv__Authentication_Request__Sequence__fini(rosauth__srv__Authentication_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosauth__srv__Authentication_Request__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosauth__srv__Authentication_Request__Sequence *
rosauth__srv__Authentication_Request__Sequence__create(size_t size)
{
  rosauth__srv__Authentication_Request__Sequence * array = (rosauth__srv__Authentication_Request__Sequence *)malloc(sizeof(rosauth__srv__Authentication_Request__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rosauth__srv__Authentication_Request__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rosauth__srv__Authentication_Request__Sequence__destroy(rosauth__srv__Authentication_Request__Sequence * array)
{
  if (array) {
    rosauth__srv__Authentication_Request__Sequence__fini(array);
  }
  free(array);
}


bool
rosauth__srv__Authentication_Response__init(rosauth__srv__Authentication_Response * msg)
{
  if (!msg) {
    return false;
  }
  // authenticated
  return true;
}

void
rosauth__srv__Authentication_Response__fini(rosauth__srv__Authentication_Response * msg)
{
  if (!msg) {
    return;
  }
  // authenticated
}

rosauth__srv__Authentication_Response *
rosauth__srv__Authentication_Response__create()
{
  rosauth__srv__Authentication_Response * msg = (rosauth__srv__Authentication_Response *)malloc(sizeof(rosauth__srv__Authentication_Response));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosauth__srv__Authentication_Response));
  bool success = rosauth__srv__Authentication_Response__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rosauth__srv__Authentication_Response__destroy(rosauth__srv__Authentication_Response * msg)
{
  if (msg) {
    rosauth__srv__Authentication_Response__fini(msg);
  }
  free(msg);
}


bool
rosauth__srv__Authentication_Response__Sequence__init(rosauth__srv__Authentication_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rosauth__srv__Authentication_Response * data = NULL;
  if (size) {
    data = (rosauth__srv__Authentication_Response *)calloc(size, sizeof(rosauth__srv__Authentication_Response));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosauth__srv__Authentication_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosauth__srv__Authentication_Response__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosauth__srv__Authentication_Response__Sequence__fini(rosauth__srv__Authentication_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosauth__srv__Authentication_Response__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosauth__srv__Authentication_Response__Sequence *
rosauth__srv__Authentication_Response__Sequence__create(size_t size)
{
  rosauth__srv__Authentication_Response__Sequence * array = (rosauth__srv__Authentication_Response__Sequence *)malloc(sizeof(rosauth__srv__Authentication_Response__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rosauth__srv__Authentication_Response__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rosauth__srv__Authentication_Response__Sequence__destroy(rosauth__srv__Authentication_Response__Sequence * array)
{
  if (array) {
    rosauth__srv__Authentication_Response__Sequence__fini(array);
  }
  free(array);
}
