// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from rosauth:srv/Authentication.idl
// generated code does not contain a copyright notice

#ifndef ROSAUTH__SRV__DETAIL__AUTHENTICATION__FUNCTIONS_H_
#define ROSAUTH__SRV__DETAIL__AUTHENTICATION__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "rosauth/msg/rosidl_generator_c__visibility_control.h"

#include "rosauth/srv/detail/authentication__struct.h"

/// Initialize srv/Authentication message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * rosauth__srv__Authentication_Request
 * )) before or use
 * rosauth__srv__Authentication_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_rosauth
bool
rosauth__srv__Authentication_Request__init(rosauth__srv__Authentication_Request * msg);

/// Finalize srv/Authentication message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosauth
void
rosauth__srv__Authentication_Request__fini(rosauth__srv__Authentication_Request * msg);

/// Create srv/Authentication message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * rosauth__srv__Authentication_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rosauth
rosauth__srv__Authentication_Request *
rosauth__srv__Authentication_Request__create();

/// Destroy srv/Authentication message.
/**
 * It calls
 * rosauth__srv__Authentication_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosauth
void
rosauth__srv__Authentication_Request__destroy(rosauth__srv__Authentication_Request * msg);


/// Initialize array of srv/Authentication messages.
/**
 * It allocates the memory for the number of elements and calls
 * rosauth__srv__Authentication_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosauth
bool
rosauth__srv__Authentication_Request__Sequence__init(rosauth__srv__Authentication_Request__Sequence * array, size_t size);

/// Finalize array of srv/Authentication messages.
/**
 * It calls
 * rosauth__srv__Authentication_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosauth
void
rosauth__srv__Authentication_Request__Sequence__fini(rosauth__srv__Authentication_Request__Sequence * array);

/// Create array of srv/Authentication messages.
/**
 * It allocates the memory for the array and calls
 * rosauth__srv__Authentication_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rosauth
rosauth__srv__Authentication_Request__Sequence *
rosauth__srv__Authentication_Request__Sequence__create(size_t size);

/// Destroy array of srv/Authentication messages.
/**
 * It calls
 * rosauth__srv__Authentication_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosauth
void
rosauth__srv__Authentication_Request__Sequence__destroy(rosauth__srv__Authentication_Request__Sequence * array);

/// Initialize srv/Authentication message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * rosauth__srv__Authentication_Response
 * )) before or use
 * rosauth__srv__Authentication_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_rosauth
bool
rosauth__srv__Authentication_Response__init(rosauth__srv__Authentication_Response * msg);

/// Finalize srv/Authentication message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosauth
void
rosauth__srv__Authentication_Response__fini(rosauth__srv__Authentication_Response * msg);

/// Create srv/Authentication message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * rosauth__srv__Authentication_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rosauth
rosauth__srv__Authentication_Response *
rosauth__srv__Authentication_Response__create();

/// Destroy srv/Authentication message.
/**
 * It calls
 * rosauth__srv__Authentication_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosauth
void
rosauth__srv__Authentication_Response__destroy(rosauth__srv__Authentication_Response * msg);


/// Initialize array of srv/Authentication messages.
/**
 * It allocates the memory for the number of elements and calls
 * rosauth__srv__Authentication_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosauth
bool
rosauth__srv__Authentication_Response__Sequence__init(rosauth__srv__Authentication_Response__Sequence * array, size_t size);

/// Finalize array of srv/Authentication messages.
/**
 * It calls
 * rosauth__srv__Authentication_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosauth
void
rosauth__srv__Authentication_Response__Sequence__fini(rosauth__srv__Authentication_Response__Sequence * array);

/// Create array of srv/Authentication messages.
/**
 * It allocates the memory for the array and calls
 * rosauth__srv__Authentication_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rosauth
rosauth__srv__Authentication_Response__Sequence *
rosauth__srv__Authentication_Response__Sequence__create(size_t size);

/// Destroy array of srv/Authentication messages.
/**
 * It calls
 * rosauth__srv__Authentication_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosauth
void
rosauth__srv__Authentication_Response__Sequence__destroy(rosauth__srv__Authentication_Response__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // ROSAUTH__SRV__DETAIL__AUTHENTICATION__FUNCTIONS_H_
