// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rosauth:srv/Authentication.idl
// generated code does not contain a copyright notice

#ifndef ROSAUTH__SRV__DETAIL__AUTHENTICATION__STRUCT_HPP_
#define ROSAUTH__SRV__DETAIL__AUTHENTICATION__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 't'
// Member 'end'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rosauth__srv__Authentication_Request __attribute__((deprecated))
#else
# define DEPRECATED__rosauth__srv__Authentication_Request __declspec(deprecated)
#endif

namespace rosauth
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct Authentication_Request_
{
  using Type = Authentication_Request_<ContainerAllocator>;

  explicit Authentication_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : t(_init),
    end(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->mac = "";
      this->client = "";
      this->dest = "";
      this->rand = "";
      this->level = "";
    }
  }

  explicit Authentication_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : mac(_alloc),
    client(_alloc),
    dest(_alloc),
    rand(_alloc),
    t(_alloc, _init),
    level(_alloc),
    end(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->mac = "";
      this->client = "";
      this->dest = "";
      this->rand = "";
      this->level = "";
    }
  }

  // field types and members
  using _mac_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _mac_type mac;
  using _client_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _client_type client;
  using _dest_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _dest_type dest;
  using _rand_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _rand_type rand;
  using _t_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _t_type t;
  using _level_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _level_type level;
  using _end_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _end_type end;

  // setters for named parameter idiom
  Type & set__mac(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->mac = _arg;
    return *this;
  }
  Type & set__client(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->client = _arg;
    return *this;
  }
  Type & set__dest(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->dest = _arg;
    return *this;
  }
  Type & set__rand(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->rand = _arg;
    return *this;
  }
  Type & set__t(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->t = _arg;
    return *this;
  }
  Type & set__level(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->level = _arg;
    return *this;
  }
  Type & set__end(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->end = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rosauth::srv::Authentication_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosauth::srv::Authentication_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosauth::srv::Authentication_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosauth::srv::Authentication_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosauth::srv::Authentication_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosauth::srv::Authentication_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosauth::srv::Authentication_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosauth::srv::Authentication_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosauth::srv::Authentication_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosauth::srv::Authentication_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosauth__srv__Authentication_Request
    std::shared_ptr<rosauth::srv::Authentication_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosauth__srv__Authentication_Request
    std::shared_ptr<rosauth::srv::Authentication_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Authentication_Request_ & other) const
  {
    if (this->mac != other.mac) {
      return false;
    }
    if (this->client != other.client) {
      return false;
    }
    if (this->dest != other.dest) {
      return false;
    }
    if (this->rand != other.rand) {
      return false;
    }
    if (this->t != other.t) {
      return false;
    }
    if (this->level != other.level) {
      return false;
    }
    if (this->end != other.end) {
      return false;
    }
    return true;
  }
  bool operator!=(const Authentication_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Authentication_Request_

// alias to use template instance with default allocator
using Authentication_Request =
  rosauth::srv::Authentication_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rosauth


#ifndef _WIN32
# define DEPRECATED__rosauth__srv__Authentication_Response __attribute__((deprecated))
#else
# define DEPRECATED__rosauth__srv__Authentication_Response __declspec(deprecated)
#endif

namespace rosauth
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct Authentication_Response_
{
  using Type = Authentication_Response_<ContainerAllocator>;

  explicit Authentication_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->authenticated = false;
    }
  }

  explicit Authentication_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->authenticated = false;
    }
  }

  // field types and members
  using _authenticated_type =
    bool;
  _authenticated_type authenticated;

  // setters for named parameter idiom
  Type & set__authenticated(
    const bool & _arg)
  {
    this->authenticated = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rosauth::srv::Authentication_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosauth::srv::Authentication_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosauth::srv::Authentication_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosauth::srv::Authentication_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosauth::srv::Authentication_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosauth::srv::Authentication_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosauth::srv::Authentication_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosauth::srv::Authentication_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosauth::srv::Authentication_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosauth::srv::Authentication_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosauth__srv__Authentication_Response
    std::shared_ptr<rosauth::srv::Authentication_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosauth__srv__Authentication_Response
    std::shared_ptr<rosauth::srv::Authentication_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Authentication_Response_ & other) const
  {
    if (this->authenticated != other.authenticated) {
      return false;
    }
    return true;
  }
  bool operator!=(const Authentication_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Authentication_Response_

// alias to use template instance with default allocator
using Authentication_Response =
  rosauth::srv::Authentication_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rosauth

namespace rosauth
{

namespace srv
{

struct Authentication
{
  using Request = rosauth::srv::Authentication_Request;
  using Response = rosauth::srv::Authentication_Response;
};

}  // namespace srv

}  // namespace rosauth

#endif  // ROSAUTH__SRV__DETAIL__AUTHENTICATION__STRUCT_HPP_
